# gcp::Mesomery Class Reference

`#include <gcp/mesomery.h>`

Inheritance diagram for gcp::Mesomery:

List of all members.

## Public Member Functions

| Mesomery ()
bool | Load (xmlNodePtr node)
bool | Build (std::list< gcu::Object * > &Children) throw (std::invalid_argument)
void | Transform2D (gcu::Matrix2D &m, double x, double y)
bool | BuildContextualMenu (GtkUIManager *UIManager, gcu::Object *object, double x, double y)
bool | OnSignal (gcu::SignalId Signal, gcu::Object *Child)
bool | Validate (bool split)
void | Align ()
double | GetYAlign ()

## Detailed Description

Represents mesomery relationships.

Definition at line 37 of file mesomery.h.

## Constructor & Destructor Documentation

gcp::Mesomery::Mesomery | ( |  | ) |

The default constructor. Builds a new empty mesomery relationship.

## Member Function Documentation

bool gcp::Mesomery::Load | ( | xmlNodePtr | node | ) | `[virtual]`

Parameters:

  | node,: | a pointer to the xmlNode containing the serialized arrow.

Used to load an arrow in memory.

Returns:
  true on succes, false otherwise.

Reimplemented from gcu::Object.

bool gcp::Mesomery::Build | ( | std::list< gcu::Object * > & | Children | ) | throw (std::invalid_argument)`[virtual]`

Parameters:

  | Children | the molecules and arrow involved in the mesomery.

Tries to associate mesomers and arrows so that the relationship is clearly established and aligns the objects. On failure, it throws an std::invalid_argument exception.

Returns:
  true on success.

Reimplemented from gcu::Object.

void gcp::Mesomery::Transform2D | ( | gcu::Matrix2D & | m,
|  | double | x,
|  | double | y |
| ) |  |  | `[virtual]`

Parameters:

  | m | the Matrix2D of the transformation.
  | x | the x component of the center of the transformation.
  | y | the y component of the center of the transformation.

Mesomeries can't be currently rotated. This method don't do anything. It is just there to inhibit the default behavior.

Reimplemented from gcu::Object.

bool gcp::Mesomery::BuildContextualMenu | ( | GtkUIManager * | UIManager,
|  | gcu::Object * | object,
|  | double | x,
|  | double | y |
| ) |  |  | `[virtual]`

Parameters:

  | UIManager | the GtkUIManager to populate.
  | object | the Object on which occured the mouse click.
  | x | x coordinate of the mouse click.
  | y | y coordinate of the mouse click.

Builds the contextual menu for the mesomery.

Returns:
  true (failure would be a bug).

Reimplemented from gcu::Object.

bool gcp::Mesomery::OnSignal | ( | gcu::SignalId | Signal,
|  | gcu::Object * | Child |
| ) |  |  | `[virtual]`

Parameters:

  | Signal | the appropriate SignalId
  | Child | the child which emitted the signal or NULL

This function is called by the framework one of the molecules or arrows has changed. Realigns if the mesomery is still valid or destroys it.

Returns:
  true to propagate the signal to the parent.

Reimplemented from gcu::Object.

bool gcp::Mesomery::Validate | ( | bool | split | ) |

Parameters:

  | split | whether to split the mesomery when arrows are missing.

Checks the validity of the mesomery, at least that each arrow is associated with two mesomers and all mesomers are related by arrows. Currently it does not check that the molecules are really mesomeric, but this might be implemented in the future.

Returns:
  true if the mesomery is valid or could be splitted, false otherwise.

void gcp::Mesomery::Align | ( |  | ) |

Aligns the children.

double gcp::Mesomery::GetYAlign | ( |  | ) | `[virtual]`

Returns:
  the alignment ordinate of the top mesomer.

Reimplemented from gcu::Object.

The documentation for this class was generated from the following file:

- mesomery.h